# RandallReflectivity


  Synthetic Seismogram code for complete synthetics using spectral technique
    for Moment Tensor and Point Force sources in flat layered media

    Funded by Treaty Verification Program, Lawrence Livermore National Lab

    George Randall, Dept. of Geological Sciences, University of South Carolina
           ger@tigger.seis.scarolina.edu
    Steve Taylor, Los Alamos National Lab (formerly at Lawrence Livermore National Lab)
           taylor@beta.lanl.gov

        based on
       "Seismic Wave Propagation in Stratified Media" B.L.N. Kennett,
        Cambridge University Press, 1983

    Many useful discussions with and testing by
    Chuck Ammon, Harley Benz, and Bill Walter
    are gratefully acknowledged.

# Compiling (at least on Ubuntu)

sudo apt install build-essential gfortran

For scalar codes (non-parallel) use:
```
sudo apt install gfortran build-essential
make scalarf
make scalard
```
for parallel codes using OpenMPI:
```
sudo apt update
sudo apt install openmpi-bin libopenmpi-dev
make parallelf
make paralleld
```

Note the makefile should use the c preprocessor in 'traditional' mode to avoid
whitespace removal:
```
CPP = cpp -traditional-cpp
```

Input file format:
```
repeating for num layers:
thick vp vs rho qp qs  x x x x     I think the last 4 are freq parameters for anisotropy but are not used by the code
last layer (halfspace) has thickness 0

then the control values:
Slowness: lowcut lowpass highpass highcut controlfac
Freq: fmin fmax nyquist numtimepoints
Dist: dist (0 for single, >0 for regular, <0 for irregular) az
distances line:
if singular: dist az
if regular: mindist deltadist numdist
if irregular: numdistancesthen lin with distances
sourcedepth
receiverdepth
if mgenkennett, moment tensor as mxx mxy mxz myy myz mzz,
where x == north, y == east, z == down
```
