      subroutine deldisp(p,f,islyr,d,nlyrs)
         complex p,f
         integer islyr,nlyrs
         real d
c
c     compute the displacement transfer function of the medium
c     to upgoing and down going waves for a given
c     slowness p and frequency f
c     source is in layer islyr, and depth d from top of layer
c     model has total nlyrs including half space below
c
      include 'kennet.inc'
      complex rfspp,rfsps,rfssp,rfsss,rfssh
      complex srfspp,srfsps,srfssp,srfsss,srfssh
      complex drfspp,drfsps,drfssp,drfsss,drfssh
      complex rslpp,rslps,rslsp,rslss,rslsh
      complex srslpp,srslps,srslsp,srslss,srslsh
      complex drslpp,drslps,drslsp,drslss,drslsh
      complex rdvpup,rdvsup,rdrpup,rdrsup,rdtsup
      complex srdvpup,srdvsup,srdrpup,srdrsup,srdtsup
      complex drdvpup,drdvsup,drdrpup,drdrsup,drdtsup
      complex t11,t12,t21,t22,l11,l12,l21,l22,lsh
      complex xpp,xps,xsp,xss,xsh,ypp,yps,ysp,yss,ysh
c     complex*16 det
      complex det
      complex i,one,w,twopi,oo,to
      complex phap,phas,phapp,phaps,phass
      complex phbp,phbs,phbpp,phbps,phbss
      complex dphap,dphas,dphapp,dphaps,dphass
      complex dphbp,dphbs,dphbpp,dphbps,dphbss
      integer plyr
      complex cphs
      external cphs,rcvrfn,rufs,refl,burec
      data i,one,twopi/(0.,1.),(1.,0.),(6.2831853,0.)/
      data oo,to/(1.,1.),(2.,1.)/
      w = twopi * f
c
c      compute receiver function, free surface displacement
c      from a plane wave incident from a source layer (islyr)
c      1st part of (7.36)
c      use rcvrfs for surface receiver and Rurs
c      burec for buried receiver, and rufs for Rufs
c
      call rcvrfn(p,f,islyr,rdvpup,rdvsup,rdrpup,rdrsup,rdtsup,
     *                      rfspp,rfsps,rfssp,rfsss,rfssh)
c     call rcvrfs(p,f,islyr,rdvpup,rdrpup,rdvsup,rdrsup,rdtsup,
c    *                      rfspp,rfsps,rfssp,rfsss,rfssh)
c
c
c      Rd(SL) in (7.36)
c
c     call refl(p,f,islyr,nlyrs,rslpp,rslps,rslsp,rslss,rslsh)
      call refltd(p,f,islyr,nlyrs,rslpp,rslps,rslsp,rslss,rslsh)
c
c     assemble the terms with appropriate phase delays
c
      phap = cphs( -i*w*xi(islyr)*d )
      phas = cphs( -i*w*eta(islyr)*d )
c      phapp = cphs( -i*2.*w*xi(islyr)*d )
c      phass = cphs( -i*2.*w*eta(islyr)*d )
c      phaps = cphs( -i*w*(xi(islyr)+eta(islyr))*d )
      phapp = phap * phap
      phass = phas * phas
      phaps = phap * phas
      srdvpup = rdvpup
      srdrpup = rdrpup
      srdvsup = rdvsup
      srdrsup = rdrsup
      srdtsup = rdtsup
      srfspp = rfspp
      srfsps = rfsps
      srfssp = rfssp
      srfsss = rfsss
      srfssh = rfssh
      rdvpup = rdvpup * phap
      rdrpup = rdrpup * phap
      rdvsup = rdvsup * phas
      rdrsup = rdrsup * phas
      rdtsup = rdtsup * phas
      rfspp = rfspp * phapp
      rfsps = rfsps * phaps
      rfssp = rfssp * phaps
      rfsss = rfsss * phass
      rfssh = rfssh * phass
c
      dphap = cphs( -i*w*dxi(islyr)*d )
      dphas = cphs( -i*w*deta(islyr)*d )
c      dphapp = cphs( -i*2.*w*dxi(islyr)*d )
c      dphass = cphs( -i*2.*w*deta(islyr)*d )
c      dphaps = cphs( -i*w*(dxi(islyr)+deta(islyr))*d )
      dphapp = dphap * dphap
      dphass = dphas * dphas
      dphaps = dphap * dphas
c
      phbp = cphs( -i*w*xi(islyr)*(thik(islyr)-d) )
      phbs = cphs( -i*w*eta(islyr)*(thik(islyr)-d) )
c      phbpp = cphs( -i*2.*w*xi(islyr)*(thik(islyr)-d) )
c      phbss = cphs( -i*2.*w*eta(islyr)*(thik(islyr)-d) )
c      phbps = cphs( -i*w*(xi(islyr)+eta(islyr))*(thik(islyr)-d) )
      phbpp = phbp * phbp
      phbss = phbs * phbs
      phbps = phbp * phbs
      srslpp = rslpp
      srslps = rslps
      srslsp = rslsp
      srslss = rslss
      srslsh = rslsh
      rslpp = rslpp * phbpp
      rslps = rslps * phbps
      rslsp = rslsp * phbps
      rslss = rslss * phbss
      rslsh = rslsh * phbss
c
      dphbp = cphs( -i*w*dxi(islyr)*(thik(islyr)-d) )
      dphbs = cphs( -i*w*deta(islyr)*(thik(islyr)-d) )
c      dphbpp = cphs( -i*2.*w*dxi(islyr)*(thik(islyr)-d) )
c      dphbss = cphs( -i*2.*w*deta(islyr)*(thik(islyr)-d) )
c      dphbps = cphs( -i*w*(dxi(islyr)+deta(islyr))*(thik(islyr)-d) )
      dphbpp = dphbp * dphbp
      dphbss = dphbs * dphbs
      dphbps = dphbp * dphbs
c
      do 10 plyr = 1, nlyrs
      if ( plyr .le. islyr ) then
	 call delrcvru(p,f,plyr,islyr,drdvpup,drdvsup,drdrpup,drdrsup,drdtsup,
     *                 drfspp,drfsps,drfssp,drfsss,drfssh)
	 if ( plyr .ne. islyr ) then
            dvpup(plyr) = drdvpup * phap
            drpup(plyr) = drdrpup * phap
            dvsup(plyr) = drdvsup * phas
            drsup(plyr) = drdrsup * phas
            dtsup(plyr) = drdtsup * phas
            xpp = drfspp * phapp
            xps = drfsps * phaps
            xsp = drfssp * phaps
            xss = drfsss * phass
            xsh = drfssh * phass
            ypp = rslpp
            yps = rslps
            ysp = rslsp
            yss = rslss
            ysh = rslsh
	 else
            dvpup(plyr) = drdvpup * dphap
            drpup(plyr) = drdrpup * dphap
            dvsup(plyr) = drdvsup * dphas
            drsup(plyr) = drdrsup * dphas
            dtsup(plyr) = drdtsup * dphas
            xpp = drfspp * dphapp
            xps = drfsps * dphaps
            xsp = drfssp * dphaps
            xss = drfsss * dphass
            xsh = drfssh * dphass
c           ypp = srslpp * dphbpp
c           yps = srslps * dphbps
c           ysp = srslsp * dphbps
c           yss = srslss * dphbss
c           ysh = srslsh * dphbss
	 endif
       endif
       if ( plyr .ge. islyr ) then
	 call delrefl(p,f,plyr,islyr,nlyrs,drslpp,drslps,drslsp,drslss,drslsh)
	 if ( plyr .ne. islyr ) then
            ypp = drslpp * phbpp
            yps = drslps * phbps
            ysp = drslsp * phbps
            yss = drslss * phbss
            ysh = drslsh * phbss
            dvpup(plyr) = rdvpup
            dvsup(plyr) = rdvsup
            drpup(plyr) = rdrpup
            drsup(plyr) = rdrsup
            dtsup(plyr) = rdtsup
            xpp = rfspp
            xps = rfsps
            xsp = rfssp
            xss = rfsss
            xsh = rfssh
          else
            ypp = drslpp * dphbpp
            yps = drslps * dphbps
            ysp = drslsp * dphbps
            yss = drslss * dphbss
            ysh = drslsh * dphbss
c           dvpup(plyr) = srdvpup * dphapp
c           dvsup(plyr) = srdvsup * dphaps
c           drpup(plyr) = srdrpup * dphaps
c           drsup(plyr) = srdrsup * dphass
c           dtsup(plyr) = srdtsup * dphass
c           xpp = srfspp * dphapp
c           xps = srfsps * dphaps
c           xsp = srfssp * dphaps
c           xss = srfsss * dphass
c           xsh = srfssh * dphass
         endif
      endif
c
c     the receiver function or buried receiver for the path to the surface/receiver
c
c     dvpup(plyr) = rdvpup * php
c     dvsup(plyr) = rdvsup * phs
c     drpup(plyr) = rdrpup * php
c     drsup(plyr) = rdrsup * phs
c     dtsup(plyr) = rdtsup * phs
c
c      relectivity from a plane wave incident from 
c      below, see Rufs in (7.36)
c      x[ps][psh] = Rufs[ps][psh]
c
c
c      Rd(SL) in (7.36)
c      y[ps][psh] = RdSL[ps][psh]
c
c
c     l11 = one - rslpp*rfspp - rslps*rfssp
c     l12 = -rslpp*rfsps - rslps*rfsss
c     l21 = -rslsp*rfspp - rslss*rfssp
c     l22 = one - rslsp*rfsps - rslss*rfsss
c
c     the following 8 lines serve to keep the dynamic
c     range of the numbers in l to a reasonable level
c     basically adding and subtracting one, and letting
c     the truncation in normalization before a floating add
c     take care of numbers too small to be significant
c     physically, but able to cause underflow in products
c     that follow, bombing the code needlessly....
c     if machine sets underflow to zero, this could be
c     removed, and returned to the inital straightforward
c     coding.
c
c                   SL  fS
c       form [I - Rd  Ru  ]**-1 in (7.36)
c
      l11 = -oo - ypp*xpp - yps*xsp
      l12 = -oo - ypp*xps - yps*xss
      l21 = -oo - ysp*xpp - yss*xsp
      l22 = -oo - ysp*xps - yss*xss
      l11 = to + l11
      l12 = oo + l12
      l21 = oo + l21
      l22 = to + l22
      det = l11*l22 - l12*l21
      det = one / det
      l12 = -l12*det
      l21 = -l21*det
      t11 = l11*det
      l11 = l22*det
      l22 = t11
      lsh = one / ( one - ysh*xsh )
c
c      mult by W[I - Rd(0S)*R(0f)]**-1 Tu(0S)  from rcvrfn
c      or Mur + Mdr*Ru(fR)[I - Rd(RS)*Ru(fR)]**-1 Tu(RS)
c
      t11 = dvpup(plyr)*l11 + dvsup(plyr)*l21
      t12 = dvpup(plyr)*l12 + dvsup(plyr)*l22
      t21 = drpup(plyr)*l11 + drsup(plyr)*l21
      t22 = drpup(plyr)*l12 + drsup(plyr)*l22
      dvpup(plyr) = t11
      dvsup(plyr) = t12
      drpup(plyr) = t21
      drsup(plyr) = t22
      dtsup(plyr) = dtsup(plyr)*lsh
c
c                         sL
c      post multiply by Rd
c
      dvpdn(plyr) = t11*ypp + t12*ysp
      dvsdn(plyr) = t11*yps + t12*yss
      drpdn(plyr) = t21*ypp + t22*ysp
      drsdn(plyr) = t21*yps + t22*yss
      dtsdn(plyr) = dtsup(plyr)*ysh
c
 10   continue
c
      return
      end
