      subroutine delsrcvec( m, p, isrc  )
         integer m, isrc
         complex p
c
c     compute the upward adnd downward p adnd s waves from a
c     symmetric moment tensor source, for integer angular order m
c     adnd slowness p, for source isrc, (4.64) kennett
c
c     fix sign of +1 and -1 terms give results consistent with crfl and others
c
      include 'kennet.inc'
c
c     su,sv,sw,sp,ss,st are the components of the jump in
c     the displacement - stress vector
c     from kennett (1983) (4.59 - 4.60)
c
      complex su,sv,sw,sp,ss,st,i,zero
      data i,zero/(0.,1.),(0.,0.)/
c
c     calculate up adnd downgoing P,SV,SH at source (4.64) kennett
c
      if ( m .eq. 0 ) then
         su = mzz(isrc)/(drhos*dalfas*dalfas)
         ss = p*( .5*(mxx(isrc)+myy(isrc))
     *         - mzz(isrc)*(1. - 2.*dbetas*dbetas/(dalfas*dalfas)))
         dpup0(isrc) = i*(dmds21*ss - dnds11*su)
         dsvup0(isrc) = i*(dmds22*ss - dnds12*su)
         dpdn0(isrc) = i*(dmus21*ss - dnus11*su)
         dsvdn0(isrc) = i*(dmus22*ss - dnus12*su)
         dshup0(isrc) = zero
         dshdn0(isrc) = zero
       endif
      if ( m .eq. 1 ) then
         sv = -( mxz(isrc) - i*myz(isrc) )/(2.*drhos*dbetas*dbetas)
         sw = -(-myz(isrc) - i*mxz(isrc) )/(2.*drhos*dbetas*dbetas)
         dpupp1(isrc) =-i*dnds21*sv
         dsvupp1(isrc) =-i*dnds22*sv
         dpdnp1(isrc) =-i*dnus21*sv
         dsvdnp1(isrc) =-i*dnus22*sv
         dshupp1(isrc) =-i*dndssh*sw
         dshdnp1(isrc) =-i*dnussh*sw
       endif
      if ( m .eq. -1 ) then
         sv = -(-mxz(isrc) - i*myz(isrc) )/(2.*drhos*dbetas*dbetas)
         sw = -( myz(isrc) - i*mxz(isrc) )/(2.*drhos*dbetas*dbetas)
         dpupm1(isrc) = -i*dnds21*sv
         dsvupm1(isrc) = -i*dnds22*sv
         dpdnm1(isrc) = -i*dnus21*sv
         dsvdnm1(isrc) = -i*dnus22*sv
         dshupm1(isrc) = -i*dndssh*sw
         dshdnm1(isrc) = -i*dnussh*sw
       endif
      if ( m .eq. 2 ) then
         ss = .25*p*( myy(isrc) - mxx(isrc) + 2.*i*mxy(isrc) )
         st = .25*p*( i*(mxx(isrc) - myy(isrc)) + 2.*mxy(isrc) )
         dpupp2(isrc) = i*dmds21*ss
         dsvupp2(isrc) = i*dmds22*ss
         dpdnp2(isrc) = i*dmus21*ss
         dsvdnp2(isrc) = i*dmus22*ss
         dshupp2(isrc) = i*dmdssh*st
         dshdnp2(isrc) = i*dmussh*st
       endif
      if ( m .eq. -2 ) then
         ss = .25*p*( myy(isrc) - mxx(isrc) - 2.*i*mxy(isrc) )
         st = .25*p*( -i*(mxx(isrc) - myy(isrc)) + 2.*mxy(isrc) )
         dpupm2(isrc) = i*dmds21*ss
         dsvupm2(isrc) = i*dmds22*ss
         dpdnm2(isrc) = i*dmus21*ss
         dsvdnm2(isrc) = i*dmus22*ss
         dshupm2(isrc) = i*dmdssh*st
         dshdnm2(isrc) = i*dmussh*st
       endif
      return
      end
